package ru.dbotthepony.kstarbound.lua;

import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.ptr.LongByReference;

import java.io.File;

public final class LuaJNA {
	public static native int lua_pcallk(long p, int numArgs, int numResults, int msgh, Pointer ctx, LuaJNADynamic.lua_KFunction callback);
	public static native int lua_callk(long p, int numArgs, int numResults, Pointer ctx, LuaJNADynamic.lua_KFunction callback);

	public static native Pointer luaL_newstate();
	public static native void lua_close(long pointer);

	// Стандартные библиотеки
	public static native void luaopen_base(long pointer);
	public static native void luaopen_package(long pointer);
	public static native void luaopen_coroutine(long pointer);
	public static native void luaopen_table(long pointer);
	public static native void luaopen_io(long pointer);
	public static native void luaopen_os(long pointer);
	public static native void luaopen_string(long pointer);
	public static native void luaopen_math(long pointer);
	public static native void luaopen_utf8(long pointer);
	public static native void luaopen_debug(long pointer);

	public static native int lua_checkstack(long pointer, int value);
	public static native int lua_absindex(long pointer, int value);
	public static native int lua_gettop(long pointer);

	public static native Pointer lua_tolstring(long pointer, int index, LongByReference size);

	public static native void lua_setglobal(long pointer, String name);

	static {
		Native.register(new File("./lua54.dll").getAbsolutePath());
	}
}
